//
//  BannerAd_Vc.swift
//  DemoApp
//
//  Created by Djax on 26/08/22.
//

import UIKit
import SDK_Lib
import WebKit

class BannerAd_Vc: UIViewController {

    @IBOutlet weak var svView: UIScrollView!
    @IBOutlet weak var bannerView1: WKWebView!
    @IBOutlet weak var bannerView2: WKWebView!
    @IBOutlet weak var txtLbl: UILabel!
    @IBOutlet weak var txtLbl1: UILabel!

    @IBOutlet weak var overallWebView: WKWebView!
    
    @IBOutlet weak var banner1WebHeightConstraint: NSLayoutConstraint?
    
    @IBOutlet weak var clickBtn: UIButton!
    @IBOutlet weak var clickBtnHeightConstraint: NSLayoutConstraint?

    var zoneId: String? = ""
    var strUrl:String? = ""
    var fromPage:String? = ""

    var adResponse = AdResponse()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.clickBtn.isHidden = true
        self.clickBtnHeightConstraint?.constant = 0
      
        //create the height constraint for webview
        if fromPage == "Direct Link Ad" {
            adResponse.linkDelegate = self
            adResponse.linkAdIntegration()
        }
        else if fromPage == "Image Ad" ||
                fromPage == "HTML" ||
                fromPage == "HTML5" {
            adResponse.webViewDelegate = self
            adResponse.imageAdIntegration(fromStr: self.fromPage ?? "")
        }
    }
}
extension BannerAd_Vc : WebViewUpdateDelegate {
    func updateWebView(webV: WKWebView) {
        banner1WebHeightConstraint?.constant = webV.frame.size.height
        bannerView1?.addSubview(webV)
    }
}
extension BannerAd_Vc : LinkUpdateDelegate {
    func updateLinkAd(str:String) {
        self.clickBtn.isHidden = false
        self.clickBtnHeightConstraint?.constant = 35
        self.strUrl = str
        self.clickBtn.addTarget(self, action: #selector(redirectView), for: .touchUpInside)
    }
    @objc func redirectView() {
        if let url = URL(string: self.strUrl ?? "") {
              if #available(iOS 10, *){
                  UIApplication.shared.open(url)
              }else{
                  UIApplication.shared.openURL(url)
              }
          }
    }
}
