<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
/* 
+---------------------------------------------------------------------------+
| Revive Adserver                                                           |
| http://www.revive-adserver.com                                            |
|                                                                           |
| Copyright: See the COPYRIGHT.txt file.                                    |
| License: GPLv2 or later, see the LICENSE.txt file.                        |
+---------------------------------------------------------------------------+
*/

// Require the initialisation file
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/lib/OA/Dal.php';

require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/lib/max/other/html.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_MANAGER, OA_ACCOUNT_TRAFFICKER);
OA_Permission::enforceAccessToObject('affiliates', $affiliateid);
OA_Permission::enforceAccessToObject('zones', $zoneid);

if (OA_Permission::isAccount(OA_ACCOUNT_TRAFFICKER)) {
    OA_Permission::enforceAllowed(OA_PERM_ZONE_INVOCATION);
}

/*-------------------------------------------------------*/
/* Store preferences									 */
/*-------------------------------------------------------*/
$session['prefs']['inventory_entities'][OA_Permission::getEntityId()]['affiliateid'] = $affiliateid;
phpAds_SessionDataStore();

//~ $oHeaderModel = MAX_displayWebsiteBreadcrumbs($affiliateid);

 //~ phpAds_PageHeader('zone-edit', $oHeaderModel);

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

// Initialise some parameters
$pageName = basename($_SERVER['SCRIPT_NAME']);
$tabIndex = 1;
$agencyId = OA_Permission::getAgencyId();
$aEntities = ['affiliateid' => $affiliateid, 'zoneid' => $zoneid];

$aOtherPublishers = Admin_DA::getPublishers(['agency_id' => $agencyId]);
$aOtherZones = Admin_DA::getZones(['publisher_id' => $affiliateid]);
MAX_displayNavigationZone($pageName, $aOtherPublishers, $aOtherZones, $aEntities);

/**  databse declaration - start **/

if($GLOBALS['_MAX']['CONF']['database']['type']=='mysql'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysql.php';
} else if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
} else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

if ($GLOBALS['_MAX']['SSL_REQUEST']) 
{
	$djprotocol='https://';
}
else
{
	$djprotocol='http://';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
$conf = $GLOBALS['_MAX']['CONF'];

/**  databse declaration - end **/

/** Connecting to Redis server **/

$redishost=$GLOBALS['_MAX']['CONF']['Redisdatabase']['host'];
$redisport=$GLOBALS['_MAX']['CONF']['Redisdatabase']['port'];
$redispassword=$GLOBALS['_MAX']['CONF']['Redisdatabase']['password'];

$redis = new Redis();
//Connecting to Redis
$redis->connect($redishost, $redisport);
if (!$redis->auth($redispassword)) { 
	throw new Exception('Failed to authenticate with Redis.');
}

/* if($redis->ping()){
	echo 'PONG';
} */
$name = $GLOBALS['_MAX']['CONF']['database']['name']; //unique key for redis

/** submit value into database  - start**/

if(isset($_POST['submit']))
{
	$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
	//$details = json_encode($_POST['bidder']);
	$bdetails = $_POST['bidder_detail'];

	$timeout = $_POST['timeout'];
	$zone_type = $_POST['zone_type'];
	$is_update = $_POST['is_update'];
	
	$affiliateid = $_GET['affiliateid'];
	$zone_id = $_GET['zoneid'];
	$details = [];
	$bidder_id = [];

	foreach($bdetails as $bname => $bvalue)
	{
		if(is_array($bvalue['value']))
		{
			$bidder_id[] = $bname;
		}else{
			$bvalue['value'] = [];
		}

		foreach($bvalue['value'] as $pname => $pvalue)
		{
		$bdetails[$bname]['value'][$pname]['val']=trim($bdetails[$bname]['value'][$pname]['val']);
		
			if($bdetails[$bname]['value'][$pname]['adelement']){
				$adunit = $bdetails[$bname]['value'][$pname]['adelement'];
			}
		
			if($_POST['bidder'][$bvalue['bidder_code']] == 'on' && $is_update)
			{			
				if(is_array($pvalue['value']))
				{
					foreach($pvalue['value'] as $sname => $svalue)
					{
						$details['bidder'][$bvalue['bidder_code']][$pvalue['name']] = trim($pvalue['val']);
						$details['bidder'][$bvalue['bidder_code']]['value'][$svalue['name']] = trim($svalue['value']);
					//	$details['bidder'][$bvalue['bidder_code']][$pvalue['name']][$svalue['name']] = trim($svalue['value']);
					}
				}else{	
					$details['bidder'][$bvalue['bidder_code']][$pvalue['name']] = trim($pvalue['val']);
				}
				
			}else{
				if(is_array($pvalue['value']))
				{
					foreach($pvalue['value'] as $sname => $svalue)
					{
						$details['bidder'][$bvalue['bidder_code']][$pvalue['name']] = trim($pvalue['val']);
						$details['bidder'][$bvalue['bidder_code']]['value'][$svalue['name']] = trim($svalue['value']);
					//	$details['bidder'][$bvalue['bidder_code']][$pvalue['name']][$svalue['name']] = trim($svalue['value']);
					}
				}else{
					$details['bidder'][$bvalue['bidder_code']][$pvalue['name']] = trim($pvalue['val']);
				}
			}	
		}
		
		if($_POST['bidder'][$bvalue['bidder_code']] == 'on')
		{
			$bdetails[] = $bdetails[$bvalue[3]];
		}

	}

	$details = serialize($details);
	$bdetails = serialize($bdetails);
	$bidder_id = serialize($bidder_id);
	$bidding_type = $_POST['bidding_type'];

	$ext = pathinfo($_POST['vid_source'], PATHINFO_EXTENSION);

	$vid_extention = explode('?', $ext);

	$vid_details = [
		'vid_source' => $_POST['vid_source'],
		'vid_width' => $_POST['vid_width'],
		'vid_height' => $_POST['vid_height'],
		'vid_extention' => 'video/'.$vid_extention[0]
	];
	$vid_details = serialize($vid_details);
	
	if($is_update){
		OA_Dal_Delivery_query("UPDATE {$table_prefix}djax_thirdparty_invocation SET bidder_detail='{$details}',bidders='{$bdetails}',bidder_id='{$bidder_id}',timeout={$timeout}, bidding_type = {$bidding_type}, vid_details = '{$vid_details}', adunit = '{$adunit}' WHERE affiliate_id={$affiliateid} AND zone_id={$zone_id}");
	}else{
	
		$query = OA_Dal_Delivery_query("INSERT INTO {$table_prefix}djax_thirdparty_invocation(affiliate_id,zone_id,bidder_detail,banner_type,bidders,bidder_id,timeout, bidding_type, vid_details,adunit) VALUES ({$affiliateid},{$zone_id},'{$details}','{$zone_type}','{$bdetails}','{$bidder_id}',{$timeout}, '{$bidding_type}', '{$vid_details}', '{$adunit}')");
	}
	$val=json_encode(['bidder_detail' => $details, 'bidders' => $bdetails, 'bidder_id' => $bidder_id, 'timeout' => $timeout, 'bidding_type' => $bidding_type, 'vid_details' => $vid_details, 'adunit' => $adunit, 'affiliate_id' => $affiliate_id, 'zone_id' => $zone_id]);
	$redis->set("{$table_prefix}djax_thirdparty_invocation_{$name}_{$zone_id}",$val);
	//$retun=$redis->get("{$table_prefix}djax_thirdparty_invocation_{$name}_{$zone_id}");
	
}
/** submit value into database  - end**/

?>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" href="assets/css/font-awesome.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://cdn.jsdelivr.net/jquery.validation/1.16.0/jquery.validate.min.js"></script>
<script src="https://cdn.jsdelivr.net/jquery.validation/1.16.0/additional-methods.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<style>
body{
	font-size: 11px;
}
div.breadcrumb h3 span.label{
	font-size : 20px;
}

#thirdLevelHeader div.breadcrumb{
	margin : 0px;
}

#settingsform1 .table td{
	font-size : 13px;
}
.expanded .label{
	color:black;
}

.container label{
	font-size: 12px;
	font-weight: normal;
}
.param_details{
	padding-left: 25px;
}

.subparam_details{
	padding-left: 50px;
}
.bidname{
	width: 18%;
	font-weight: normal;
}
.sparaname{
	width: 18%;
	font-weight: normal;
}
#submitButton{
	margin-left: 50px;
}
#chsubmitButton{
	text-align: center;
}
.param_details li input{
    border-radius: 5px;
    padding: 5px;
    border: 1px solid #ccc;
    margin-bottom: 5px;
}
div.col-sm-offset-3{
	left:30px;
margin-left:30px;
padding-top:25px;
}
div.col-sm-offset-3 > ul
{
width:60%;
}
.container
{
	margin-left: 0px;
}
#bidding_type{
	text-align: left;
}

</style>

<script>
var jq = $.noConflict(true);

function getparams(e)
{
	var bidderid = e.getAttribute('data-bidder');
	var biddername = e.getAttribute('data-bidder-name');
	var affid = "<?php echo $affiliateid;?>";

	var class_name = e.getAttribute('class');

	if(class_name.match('client_side'))
	{
		class_name = 'client_side';
	}
	else if(class_name.match('server_side'))
	{
		class_name = 'server_side';
	}
	else
	{
		class_name = 'both';
	}
	
	if(e.checked == true){

		jq.ajax({
		
			type: "GET",
			
			url:"hbidajax.php",

			data:"bidderid="+bidderid+"&affid="+affid,
			
			dataType: 'json',

			success: function(data)
			{
				jq(".param_details_"+bidderid).parent().parent().remove();
				
				var param = '<div id ="'+bidderid+'" class="form-group '+class_name+' "><div class="col-sm-offset-3" ><ul class="param_details param_details_'+bidderid+'" >';
				
				jq.each(data, function(key, value) 
				{	
					var defaultValue='';
					var prebidId ='';
					var hiddenInput ='';
					var removeattr='hidden';
					var getattr='';
					//custom - listing parameters of bidders on checking for the first time
					if(value.adunitId == 1){
						defaultValue = 'readonly';
						prebidId = value.paramval;
						prebidId = "prebid_iframe_"+<?php echo $_GET['zoneid']?>;
						paramname = value.paramname;
						value.paramval = prebidId;
						
						getattr = "hidden";
						removeattr = "";
						
						hiddenInput ='<input type="text" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][adelement]" value="'+prebidId+'" hidden>';
					}
					
					if(value.parareq == '1')
					{
						var inputname = 'bidder_detail['+bidderid+'][value]['+value.paramid+'][val]'+value.paramval+'[req]['+value.parareq+']';
						param  += '<br><br><li><div><label class="bidname">'+value.paramname+' <span style="color:red;">*</span></label><input type="hidden"  name="bidder_detail['+bidderid+'][value]['+value.paramid+'][name]" value="'+value.paramname+'">';
						param += '<input type="text" id="inputparam" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][val]'+value.paramval+'[req]['+value.parareq+']" value="'+value.paramval+'" '+ defaultValue+'> &nbsp;&nbsp; <input type="text" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][adelement]" value="'+prebidId+'" hidden>';
					}
					else
					{
						param  += '<br><br><li><div><label class="bidname">'+value.paramname+'</label><input type="hidden"  name="bidder_detail['+bidderid+'][value]['+value.paramid+'][name]" value="'+value.paramname+'">';
						param += '<input type="text" id="inputparam" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][val]'+value.paramval+'" value="'+value.paramval+'" '+ defaultValue+'> <input type="text" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][adelement]" value="'+prebidId+'" hidden>';
					}
					
					var sparaname=value.sparaname;
					var sparaid=value.sparaid;
					var sparaval=value.sparaval;
						
					if(sparaname) {
						var spname = sparaname.split(',');
						//var result = sparaname.split(',') ? 'Yes' : 'No';
						//output.innerText = result;
						
						var req =value.subparareq.split(',');
						var sparid = sparaid.split(',');

						var sparaval = sparaval.split(',');
						for (let i = 0; i < spname.length; i++) {
					
				    if(req[i] == '1' || !(sparaval))
					{
						
						param  += '<br><br><li><div><label class="sparaname">'+spname[i]+' <span style="color:red;">*</span></label><input type="hidden"  name="bidder_detail['+bidderid+'][value]['+value.paramid+'][value]['+sparid[i]+'][name]" value="'+spname[i]+'">'; 
						param += '<input type="text" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][value]['+sparid[i]+'][value]" value="'+sparaval[i]+'">';
					}
					else
					{ 
						//if(sparaval[i])
						//{
						param  += '<br><br><li><div><label class="sparaname">'+spname[i]+'</label><input type="hidden"  name="bidder_detail['+bidderid+'][value]['+value.paramid+'][value]['+sparid[i]+'][name]" value="'+spname[i]+'">'; 
						param += '<input type="text" name="bidder_detail['+bidderid+'][value]['+value.paramid+'][value]['+sparid[i]+'][value]" value="'+sparaval[i]+'">';
					//  }
					}
				}
			}

				});
				param +='</div></div></li></ul></div></div>';
							
				jq("#bid_detail_"+bidderid).after(param);
				 var divheight = $("div#"+bidderid).height();
				// var getdataheight = $("div#out_drop").height();
				 var abc = $("div#"+bidderid);
				
				 //$("div#"+bidderid).css({position:"relative"});
				
				// divheight=divheight+getdataheight;
				//$("#savech").css("top", divheight+"px");
				//$("div#out_drop").height(divheight+"px");
				
				$("#bid_detail_"+bidderid).append(abc);
			}
		});
		
	}else{
				 var abc = $("div#"+bidderid);
				
				$("#bid_detail_"+bidderid).append(abc);
		
		jq(".param_details_"+bidderid).parent().parent().remove();
		
	}

	if(jq(".param_details_"+bidderid).length > 0){
		if(jq("#submitButton").length > 0){
			jq("#submitButton").attr('id','#chsubmitButton');
		}else{
			jq("#chsubmitButton").attr('id','#submitButton');
		}
	}
	
}

</script>

<?php

$zone_query = OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT delivery from {$table_prefix}zones WHERE zoneid =  ".$_GET['zoneid']));

$condition = '';

if($zone_query['delivery'] == 6)
{
	$condition = ' AND dj_is_video::integer = 1 ';
}

if($zone_query['delivery'] == 0 || $zone_query['delivery'] == 1)
{
	$condition = ' AND dj_is_banner::integer = 1 ';
}

//get existing value - start
$exst_bid = OA_Dal_Delivery_query("SELECT * FROM {$table_prefix}djax_thirdparty_invocation WHERE affiliate_id={$affiliateid} AND zone_id={$zoneid}");

$get_bidderlist = OA_Dal_Delivery_query("SELECT DISTINCT(bl.hb_bidder_id), bl.hb_bidder_code, bl.hb_bidder_name, bl.server_side, bl.hb_ad_format FROM {$table_prefix}djax_bidder_request as r right join {$table_prefix}djax_hb_bidders_list as bl on bl.hb_bidder_id::integer = r.bidder_id::integer WHERE r.publisher_id = {$affiliateid} and r.is_deleted=0 and r.is_denied=0 and r.is_admin_deleted=0 and r.is_admin_denied =0 and r.is_approved=1 ".$condition." ");

/** if first time enter headerbidding value then list -start**/
if(!OA_Dal_Delivery_numRows($exst_bid))
{

//get bidder details and timout values
$timeout = OA_Dal_Delivery_query("SELECT request_timeout,bidding_type FROM {$table_prefix}hb_bidding_type_setting");

$tout ='';
$bidding_type = '';

//check timeout has entry or not
if(OA_Dal_Delivery_numRows($timeout) > 0){
$bid_details = OA_Dal_Delivery_fetchAssoc($timeout);
$tout = $bid_details['request_timeout'];
$bidding_type = $bid_details['bidding_type'];
}else{
$tout = 500;
$bidding_type = 1;
}

/**List bidder's which is choosed by publisher - start*/
if(OA_Dal_Delivery_numRows($get_bidderlist) > 0)
{
?>
<div class="container">
<p style="font-size: 17px;font-weight: bold;">Bidder settings</p>
<hr/>
<form method="POST" class="form-horizontal">	
<div class="form-group">
<label class="control-label col-sm-3" style="font-size: 14px;"> Request Timeout</label>
<div class="col-sm-4">
	<input type="text" name="timeout" class="form-control" value="<?php echo $tout;?>">
</div>
</div>		
<div class="form-group">        
		  <div id="savech" style="right:50px;position:absolute;">
			<button type="submit" class="btn btn-default" name="submit">Save changes</button>
			<!-- store zone type -->
			<input type="hidden" name="zone_type" value="<?php echo $aOtherZones[$zoneid]['type'];?>">
		  </div>
		</div>	
<div class="form-group">
<label class="control-label col-sm-3" style="font-size: 14px;">Bidding Type</label>
<div class="col-sm-4">
	<select class="control-label col-sm-6 form-select"  name="bidding_type" id="bidding_type">
		<option value="1" <?php echo ($brow['bidding_type'] ==1) ? "selected" : "";?>>Client Side</option>
		<option value="2" <?php echo ($brow['bidding_type'] ==2) ? "selected" : "";?>>Server Side</option>
	</select>
</div>
</div>

<?php if($zone_query['delivery'] == 6 || $zone_query['delivery'] == 8) { ?>

	<div class="form-group">
		<label class="control-label col-sm-3" style="font-size: 14px;">Video Dimension</label>
		<div class="col-sm-4">
			<input type="text" name="vid_width" placeholder="Width" required>
			<input type="text" name="vid_height" placeholder="Height" required>
		</div>
	</div>				
<?php } ?>

<?php if($zone_query['delivery'] == 6){ ?>			
	<div class="form-group">
		<label class="control-label col-sm-3" style="font-size: 14px;">Video Source</label>
		<div class="col-sm-4">
			<input type="text" name="vid_source" placeholder="Source Video">
		</div>
	</div>

<?php } ?>
	<style>
		.col-sm-offset-2 label{
			background-color:aliceblue;	 
			width:225px; 
	  	}
		#container{
			width:95%;
			padding:10px;
			overflow:hidden;
			box-sizing: border-box;
		}
		.rect{
			vertical-align:top;
			text-align:center;
		}
		.rect>div{
			margin:10px;
			cursor:move;
			cursor:grab;	
			color:black;
			font-weight:bold;
		}
    </style>
    <script>    
		function allowDrop(ev) {
			ev.preventDefault();
			var x = ev.pageX,y = ev.pageY;
			var box=document.querySelectorAll("#container .rect>div ")	
		
			box.forEach(function(element) {
				element.style.backgroundColor=""
			})
			DADES.insBefore=false
			var div=document.querySelectorAll("#container .rect")
			for (let element of div) {
				if (element.offsetLeft >= x - DADES.insideX +  DADES.cantoX &&  element.offsetTop +  element.offsetHeight/2 >= y - DADES.insideY +  DADES.cantoY){
					if (element != DADES.target.nextSibling){
						element.firstElementChild.style.backgroundColor="lightblue"
						DADES.insBefore=element
					}else{
						DADES.insBefore="noInsert"
					}
					break
				}
			}
			DADES.target.firstElementChild.style.backgroundColor="lightblue"
		}

		function drag(ev) {
			var x = ev.pageX,y = ev.pageY;
		
			for (i in document.querySelectorAll("#container .rect")){
				if (document.querySelectorAll("#container .rect")[i]==ev.target)var index = i
			}
			DADES={ 
				cantoX : ev.target.offsetLeft , cantoY : ev.target.offsetTop ,
				insideX : ev.pageX, insideY : ev.pageY,
				target :ev.target,
				index:index
			}

			ev.dataTransfer.setData("text", ev.target)   
		}

		function drop(ev) {
			ev.preventDefault()
			if (DADES.target != DADES.insBefore && DADES.insBefore!="noInsert"){	
				document.getElementById("container").style.height=document.getElementById("container").offsetHeight+"px"
				document.getElementById("container").removeChild(DADES.target);
				if (DADES.insBefore){		
					document.getElementById("container").insertBefore(DADES.target, DADES.insBefore)		
					DADES.target.setAttribute("style","width:0")
				}else{
					document.getElementById("container").appendChild(DADES.target)
				}
				setTimeout(()=>{DADES.target.setAttribute("style","transition:.1s");document.getElementById("container").style.height=""},01)
			} 
		}

		function dragEnd(){
			var div=document.querySelectorAll("#container .rect>div ")
			div.forEach(function(element) {
				element.style.backgroundColor=""
			})
		}
    </script>
<div class="form-group">
<label class="control-label col-sm-3" style="
font-size: 14px;">Bidder details</label>
</div>
<div id="container"  ondrop="drop(event)" ondragover="allowDrop(event)" >
<?php
		while($bidder_details = OA_Dal_Delivery_fetchAssoc($get_bidderlist))
		{
			$bid_type = $bidder_details['server_side'];
			$class_name = '';

			if($bid_type == 1)
			{
				$class_name = 'client_side';
			}
			else if($bid_type == 2)
			{		
				$class_name = 'server_side';
			}
			else
			{
				$class_name = 'both';
			}
			if($bidder_details['hb_bidder_name'] !="" && $bidder_details['hb_bidder_name'] !=null)
			{ ?>
				<div class="rect" draggable=true ondragstart="drag(event)" ondragend ="dragEnd()">
					<div class="form-group"  id="bid_detail_<?php echo $bidder_details['hb_bidder_id'];?>">
						<div class="col-sm-offset-2"  >					
							<label  class="control-label col-sm-6 <?=$class_name?>" style="text-align:left;">						
							<input type="checkbox" class="<?=$class_name?>" name="bidder[<?php echo $bidder_details['hb_bidder_id'];?>]" data-bidder ="<?php echo $bidder_details['hb_bidder_id'];?>"  data-bidder-name ="<?php echo $bidder_details['hb_bidder_code'];?>" onclick = "getparams(this);">					
							<?php echo $bidder_details['hb_bidder_name'];?>
							<!--this hidden used to get bidder name to store into database -->
							<input type="hidden" name="bidder_detail[<?php echo $bidder_details['hb_bidder_id'];?>][name]" value='<?php echo $bidder_details["hb_bidder_name"];?>'>
							<!--this hidden used to get bidder code to store into database -->
							<input type="hidden" name="bidder_detail[<?php echo $bidder_details['hb_bidder_id'];?>][bidder_code]" value='<?php echo $bidder_details["hb_bidder_code"];?>'>
							</label>
						</div>
					</div>
				</div>
			<?php
				}
			}
			?>
		</div>
	</div>
	<?php
}else{
	?>
	<div class="alert alert-warning">
		Currently no Bidder's avaliable for <strong><?php echo $aOtherPublishers[$affiliateid]['name'];?></strong>
	</div>
	<?php	
}/**List bidder's which is choosed by publisher - end*/
?>			
	</div>
</form>
<?php
}
else{/** if already exist headerbid value then list - start**/
	
	$existing_biddingdetail = OA_Dal_Delivery_fetchAssoc($exst_bid);
	$bidders = unserialize($existing_biddingdetail['bidders']);

	$adunit_default = $existing_biddingdetail['adunit'];
	
	$vid_details = unserialize($existing_biddingdetail['vid_details']);
	$bidding_type = $existing_biddingdetail['bidding_type'];
	$class_name = [];
	$i = 0;
	$active_bidders_keys = [];
	while($bidder_details = OA_Dal_Delivery_fetchAssoc($get_bidderlist))
	{
		$active_bidders_keys[] = $bidder_details["hb_bidder_id"];
		$active_bidders[] = $bidder_details;
		$i++;
	}
	
	$exst_bidder_ids = array_keys($bidders);
	?>
	<div class="container">
	<p style="font-size: 17px;font-weight: bold;">Bidder settings</p>
	<hr/>
	<form method="POST" class="form-horizontal">	
		<div class="form-group">
			<label class="control-label col-sm-3" style="font-size: 14px;"> Request Timeout</label>
			<div class="col-sm-4">
				<input type="text" name="timeout" class="form-control" value="<?php echo $existing_biddingdetail['timeout'];?>">
			</div>
		</div>		
		<div class="form-group">        
		  <div  id="savech" style="right:50px;position:absolute">
			<button type="submit" class="btn btn-default"  name="submit">Save changes</button>
			<!-- store zone type -->
			<input type="hidden" name="zone_type" value="<?php echo $aOtherZones[$zoneid]['type'];?>">
			<input type="hidden" name="is_update" value='1'>
		  </div>
		</div>		
		<div class="form-group">
			<label class="control-label col-sm-3" style="font-size: 14px;">Bidding Type</label>
			<div class="col-sm-4">
				<select class="control-label col-sm-6 form-select"  name="bidding_type" id="bidding_type">
					<option value="1" <?php echo ($existing_biddingdetail['bidding_type'] ==1) ? "selected" : "";?>>Client Side</option>
					<option value="2" <?php echo ($existing_biddingdetail['bidding_type'] ==2) ? "selected" : "";?>>Server Side</option>
				</select>
			</div>
		</div>	

		<?php if($zone_query['delivery'] == 6 || $zone_query['delivery'] == 8) { ?>

			<div class="form-group">
				<label class="control-label col-sm-3" style="font-size: 14px;">Video Dimension</label>
				<div class="col-sm-4">
					<input type="text" value="<?=$vid_details['vid_width']?>" name="vid_width" placeholder="Width" required>
					<input type="text" value="<?=$vid_details['vid_height']?>" name="vid_height" placeholder="Height" required>
				</div>
			</div>				
		<?php } ?>
		<?php if($zone_query['delivery'] == 6) { ?>
			<div class="form-group">
				<label class="control-label col-sm-3" style="font-size: 14px;">Video Source</label>
				<div class="col-sm-4">
					<input type="text" value="<?=$vid_details['vid_source']?>" name="vid_source" placeholder="Source Video" required>
				</div>
			</div>

		<?php } ?>

		<div class="form-group">
			<label class="control-label col-sm-3" style="font-size: 14px;">Bidder details</label>
      </div>
	  <style>
		.col-sm-offset-2 label
		{
			background-color:aliceblue;	  
		}
		#container{
			width:95%;
			padding:10px;
			overflow:hidden;
			box-sizing: border-box;
		}
		.rect{
			vertical-align:top;
			text-align:center;
		}
		.rect>div{
			margin:10px;
			cursor:move;
			cursor:grab;
			color:black;
			font-weight:bold;		
			//transition:.4s;
			//transition-delay: .12s;
		}
    </style>
    <script>
		    
function allowDrop(ev) {
	ev.preventDefault();
	var x = ev.pageX,y = ev.pageY;
	var box=document.querySelectorAll("#container .rect>div ")	
    		
	box.forEach(function(element) {
		
		element.style.backgroundColor=""
	})
	DADES.insBefore=false
	var div=document.querySelectorAll("#container .rect")
	 for (let element of div) {
	  if (element.offsetLeft >= x - DADES.insideX +  DADES.cantoX &&  element.offsetTop +  element.offsetHeight/2 >= y - DADES.insideY +  DADES.cantoY){
			if (element != DADES.target.nextSibling){
				element.firstElementChild.style.backgroundColor="lightblue"
				DADES.insBefore=element
			}else{
				DADES.insBefore="noInsert"
			}
			break
  			}
      }
	DADES.target.firstElementChild.style.backgroundColor="lightblue"
 
}
		 
function drag(ev) {
	var x = ev.pageX,y = ev.pageY;
	for (i in document.querySelectorAll("#container .rect")){
		if (document.querySelectorAll("#container .rect")[i]==ev.target)var index = i
	}
	DADES={ 
		cantoX : ev.target.offsetLeft , cantoY : ev.target.offsetTop ,
		insideX : ev.pageX, insideY : ev.pageY,
		target :ev.target,
		index:index
	}
	ev.dataTransfer.setData("text", ev.target)   
}

function drop(ev) {
	ev.preventDefault()
	if (DADES.target != DADES.insBefore && DADES.insBefore!="noInsert"){	
	document.getElementById("container").style.height=document.getElementById("container").offsetHeight+"px"
			document.getElementById("container").removeChild(DADES.target);
			if (DADES.insBefore){		
				document.getElementById("container").insertBefore(DADES.target, DADES.insBefore)		
				DADES.target.setAttribute("style","width:0")
			}else{
				document.getElementById("container").appendChild(DADES.target)
      }
			setTimeout(()=>{DADES.target.setAttribute("style","transition:.1s");document.getElementById("container").style.height=""},01)
          
  }
}

function dragEnd(){
  var div=document.querySelectorAll("#container .rect>div ")

  div.forEach(function(element) {
		element.style.backgroundColor=""
	})
      }

    </script>
	  <div id="container"  ondrop="drop(event)" ondragover="allowDrop(event)" >
	<?php
	/** List bidder details - start **/

	foreach($bidders as $bidname => $bidvalue)
	{
		$query = OA_Dal_Delivery_query("SELECT server_side FROM {$table_prefix}djax_hb_bidders_list WHERE hb_bidder_code =  '".$bidvalue['bidder_code']."'");
		$value = OA_Dal_Delivery_fetchAssoc($query);
		$bid_type = $value['server_side'];
		$class_name = '';

		if($bid_type == 1)
		{
			$class_name = 'client_side';
		}
		else if($bid_type == 2)
		{		
			$class_name = 'server_side';
		}
		else
		{
			$class_name = 'both';
		}

		/**check it was choosed (has params)**/
		if(in_array($bidname, $active_bidders_keys))
		{
			if(is_array($bidvalue['value']))
			{
			?>
				<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group" id="bid_detail_<?php echo $bidname;?>">
					<div class="col-sm-offset-2">					
						<label  class="control-label col-sm-2 <?=$class_name?>"   style="text-align:left;">						
							<input type="checkbox" class="<?=$class_name?>_checkbox bid_detail_<?php echo $bidname;?>" name="bidder[<?php echo $bidvalue['bidder_code'];?>]" data-bidder ="<?php echo $bidname;?>"  data-bidder-name ="<?php echo $bidvalue['bidder_code'];?>" onclick = "getparams(this);" checked>					
						<?php echo $bidvalue['name'];?>
						<input type="hidden" name="bidder_detail[<?php echo $bidname;?>][name]" value='<?php echo $bidvalue["name"];?>'>
						<input type="hidden" name="bidder_detail[<?php echo $bidname;?>][bidder_code]" value='<?php echo $bidvalue["bidder_code"];?>'>
						</label>
					</div>
				</div>
				</div>
				<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group">
					<div class="col-sm-offset-3">
						<ul class="param_details param_details_<?php echo $bidname;?>">
				<?php
				
				/**list param details  - start**/
				foreach($bidvalue['value'] as $paramname => $paramvalue)
				{
				?>
				
				<li>
					<div class="<?=$class_name?>_params">
						<label class="bidname"><?php echo $paramvalue['name']?></label>
						<input type="hidden" name="bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][name]" value="<?php echo $paramvalue['name']?>">

						<input type="text" name="bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][val]<?php echo $bidvalue['value'][$paramname]['val']?>" value="<?php echo $bidvalue['value'][$paramname]['val']?>" <?php echo ($bidvalue['value'][$paramname]['adelement']) ? 'readonly' : ''; ?>>

						<input type="text" name="bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][adelement]" value="<?php echo $paramvalue['adelement'] ?>" hidden>
						
						<script>
							//checking if any generated adunit param is present
							var adparam =  '<?php echo $paramname; ?>';
							var adelement = '<?php echo $bidvalue['value'][$paramname]['adelement']; ?>';
						
							if(adelement){
								$("input[name='bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][adelement]").val("");
							}

						</script>
							
						<?php
						/** check it has subparameter or not**/
						if(is_array($paramvalue['value'])){
						?>
						<ul class="subparam_details param_details_<?php echo $paramname;?>">
						<?php
						/** list subparameter - start**/
						
							foreach($paramvalue['value'] as $subparamname => $subparamvalue){
						?>
							<li>
								<div>
									<label class="bidname"><?php echo $subparamvalue['name'];?></label>
									<input type="hidden" name="bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][value][<?php echo $subparamname;?>][name]" value="<?php echo $subparamvalue['name'];?>">
									<input type="text" name="bidder_detail[<?php echo $bidname;?>][value][<?php echo $paramname;?>][value][<?php echo $subparamname;?>][value]" value="<?php echo ($subparamvalue['value']=='null')? "":$subparamvalue['value'] ;?>">
								</div>
							</li>
						<?php	
							}
							/** list subparameter - end**/
						?>
						</li>
						<?php	
						/** list parameter value **/
						}
						?>
				
					</div>
				</li>
						
				<?php	
					}
					/** list parameter details -end**/
				?>
				</ul>
					</div>
				</div>
				</div>
				<?php
			}
		
	else{/** list unchecked bidder details - start **/
		foreach($active_bidders as $value){
			$bidid = $value['hb_bidder_id'];
			if($bidid == $bidname){
				$bidname = $value['hb_bidder_name'];
				$bidcode = $value['hb_bidder_code'];
			?>
			
				<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group" id="bid_detail_<?php echo $bidid;?>">
					<div class="col-sm-offset-2">					
						<label class="control-label col-sm-2 <?=$class_name?>" style="text-align:left;">						
							<input type="checkbox" class="<?=$class_name?>_checkbox" name="bidder[<?php echo $bidcode;?>]" data-bidder ="<?php echo $bidid;?>"  data-bidder-name ="<?php echo $bidcode;?>" onclick = "getparams(this);">					
						<?php echo $bidname;?>
						<input type="hidden" name="bidder_detail[<?php echo $bidid;?>][name]" value='<?php echo $bidname;?>'>
						<input type="hidden" name="bidder_detail[<?php echo $bidid;?>][bidder_code]" value='<?php echo $bidcode;?>'>
						</label>
					</div>
				</div>
				</div>
			<?php
		}
		}
			?>
		
			<?php
	}
	}
}	/** list unchecked bidder details - end **/

			foreach ($active_bidders as $key => $value) {
				if((!in_array($value["hb_bidder_id"], $exst_bidder_ids)) && $value['hb_bidder_name']!="" && $value['hb_bidder_name'] !=null)
				{
					
					if($value['server_side'] == 1)
					{
						$class_name = 'client_side';
					}
					else if($value['server_side'] == 2)
					{		
						$class_name = 'server_side';
					}
					else
					{
						$class_name = 'both';
					}		
				
			?>
			<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group" id="bid_detail_<?php echo $value['hb_bidder_id'];?>" >
					<div class="col-sm-offset-2">					
						<label class="control-label col-sm-6 <?php echo $class_name;?>" style="text-align:left;">						
							<input type="checkbox" class="<?php echo $class_name;?>_checkbox" name="bidder[<?php echo $value['hb_bidder_name'];?>]" data-bidder ="<?php echo $value['hb_bidder_id'];?>"  data-bidder-name ="<?php echo $value['hb_bidder_code'];?>" onclick = "getparams(this);">					
						<?php echo $value['hb_bidder_name'];?>
						<!--this hidden used to get bidder name to store into database -->
						<input type="hidden" name="bidder_detail[<?php echo $value['hb_bidder_id'];?>][name]" value='<?php echo $value["hb_bidder_name"];?>'>
						<!--this hidden used to get bidder code to store into database -->
						<input type="hidden" name="bidder_detail[<?php echo $value['hb_bidder_id'];?>][bidder_code]" value='<?php echo $value["hb_bidder_code"];?>'>
						</label>
					</div>
				</div>
				</div>
			<?php
				}
			}

	/** list bidder details - end **/	
	?>
	
	</div>
		</div>
	<?php
}

/** if already exist headerbid value then list - end**/
/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

phpAds_PageFooter();

?>

<script type="text/javascript">
	
	$(document).ready(function(){

		$("#bidding_type").change(function()
		{
			change_biddingtype($(this).val());
		});

		var bidding_type = $("#bidding_type").val();

		change_biddingtype(bidding_type);

		function change_biddingtype(type)
		{
			if(type == 2)
			{
				$(".server_side").show();
				// $(".server_side_checkbox").attr('checked', true);
				$(".server_side_params").show();
				$(".server_side").show();

				// $(".client_side_checkbox").attr('checked', false);
				$(".client_side_checkbox").hide();
				$(".client_side_params").hide();
				$(".client_side").hide();
				$(".client_side_checkbox").removeAttr('checked');
			}
			else
			{
				// $(".client_side_checkbox").attr('checked', true);
				$(".client_side_checkbox").show();
				$(".client_side_params").show();
				$(".client_side").show();
				$(".client_side").show();

				$(".server_side").hide();
				// $(".server_side_checkbox").attr('checked', false);
				$(".server_side_params").hide();
				$(".server_side").hide();
			}
		}
	});

</script>
<?php
$affiliate = OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("Select name from {$table_prefix}affiliates where affiliateid=".$affiliateid));
$affiliate_name = $affiliate["name"];

?>
<script type="text/javascript">
	
	var affiliateid = '<?= $affiliateid ?>';
	var link = '<?=$djprotocol?>'+'<?=$GLOBALS['_MAX']['CONF']['webpath']['admin']?>'+'/affiliate-edit.php?affiliateid='+affiliateid;
	
	$(".entityLinks").html('<span class="entityLinks"><a href="'+link+'" class="ent inlineIcon webs">Website: <?= $affiliate_name ?></a></span>');

</script>